package dev.peerat.parser.java.tree;

import dev.peerat.parser.TokenType;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.RedirectStateTree;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class EnumValueTree extends SyntaxTree<JavaElement> {

	public EnumValueTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> value = registery.getNode(ValueTree.class);

		// ENUM VALUE
		StateTree<JavaElement> enum_value = this.current;
		StateTree<JavaElement> enum_name = enum_value
				.then((validator) -> validator.validate((token) -> token.getType().equals(TokenType.NAME)));
		enum_name.end((a, b) -> a);
		enum_name.then((validator) -> validator.validate((token) -> token.getValue().equals(";"))).end((a, b) -> a);
		enum_name.then((validator) -> validator.validate((token) -> token.getValue().equals(","))).then(enum_name);
		StateTree<JavaElement> enum_arg = enum_name
				.then((validator) -> validator.validate((token) -> token.getValue().equals("(")))
				.then(new RedirectStateTree<>(value, (global, local) -> global.set(null)));
		StateTree<JavaElement> enum_end = enum_arg
				.then((validator) -> validator.validate((token) -> token.getValue().equals(")")));
		enum_end.end((a, b) -> a);
		enum_end.then((validator) -> validator.validate((token) -> token.getValue().equals(";"))).end((a, b) -> a);
		enum_arg.then((validator) -> validator.validate((token) -> token.getValue().equals(","))).then(enum_arg);
		enum_end.then((validator) -> validator.validate((token) -> token.getValue().equals(","))).then(enum_name);
	}

}
