package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class InstanceValue extends Value{
	
	private Token newer;
	private Token token;
	private List<Value> parameters;
	
	public InstanceValue(Token newer, Token token, List<Value> parameters){
		this.newer = newer;
		this.token = token;
		this.parameters = parameters;
	}
	
	public Token getNewer(){
		return this.newer;
	}
	
	public Token getToken(){
		return token;
	}
	
	public List<Value> getParameters(){
		return this.parameters;
	}

	@Override
	public void build(Builder builder) throws Exception {
		
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(JavaVisitor<?> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		if(this.parameters != null)
			for(Value value : this.parameters){
				bag.merge(value.visit(visitor));
			}
		return bag;
	}

}
