package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class VariableAccessValue extends Value{

	private Value base;
	private Token variable;
	
	public VariableAccessValue(Value base, Token variable){
		this.base = base;
		this.variable = variable;
	}
	
	public Value base(){
		return this.base;
	}
	
	public Token getVariable(){
		return this.variable;
	}
	
	@Override
	public void build(Builder builder) throws Exception {
		
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(JavaVisitor<?> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		bag.merge(this.base.visit(visitor));
		return bag;
	}

	@Override
	public String toString(){
		return "[VariableAccessValue] "+base+"."+variable;
	}
	
}
